libzypp 17.38.15

zypp::CapDetail Class Reference

Helper providing more detailed information about a Capability. More...

`#include <zypp/Capability.h>`

Inheritance diagram for zypp::CapDetail:

## Public Types
enum | Kind { NOCAP = 0x00 , NAMED = 0x01 , VERSIONED = 0x02 , EXPRESSION = 0x04 }
enum | CapRel { REL_NONE = 0 , CAP_AND = Capability::CAP_AND , CAP_OR = Capability::CAP_OR , CAP_COND = Capability::CAP_COND , CAP_UNLESS = Capability::CAP_UNLESS , CAP_ELSE = Capability::CAP_ELSE , CAP_WITH = Capability::CAP_WITH , CAP_WITHOUT = Capability::CAP_WITHOUT , CAP_NAMESPACE = Capability::CAP_NAMESPACE , CAP_ARCH = Capability::CAP_ARCH }
| Enum values corresponding with libsolv defines. More...

## Public Member Functions
| CapDetail ()
| CapDetail (const Capability &cap_r)
| CapDetail (sat::detail::IdType id_r)
Kind | kind () const
bool | isNull () const
bool | isNamed () const
bool | isVersioned () const
bool | isSimple () const
bool | isExpression () const
Is simple: <tt>name[.arch] [op edition]</tt>
bool | hasArch () const
IdString | arch () const
IdString | name () const
Rel | op () const
Edition | ed () const

## Is expression <tt>cap op cap</tt>
Kind | _kind
sat::detail::IdType | _lhs
sat::detail::IdType | _rhs
unsigned | _flag
sat::detail::IdType | _archIfSimple
Capability | lhs () const
CapRel | capRel () const
Capability | rhs () const
void | _init ()

## Additional Inherited Members
Static Protected Member Functions inherited from zypp::sat::detail::PoolMember
static PoolImpl & | myPool ()
static bool | poolValid ()

## Detailed Description

Helper providing more detailed information about a Capability.

Capabilities are classified to be either `SIMPLE:`

name[.arch] [op edition]
with op := <|<=|=|>=|>|!=
zypp::CapDetail::name
IdString name() const
Definition Capability.h:419
zypp::CapDetail::op
Rel op() const
Definition Capability.h:420

or formed by some `EXPRESSION:`

( left_cap op right_cap )
with op := and|or|if|unless|else|with|without

Definition at line 365 of file Capability.h.

## Member Enumeration Documentation

## ◆ Kind

enum zypp::CapDetail::Kind

Enumerator
NOCAP |
NAMED |
VERSIONED |
EXPRESSION |

Definition at line 368 of file Capability.h.

## ◆ CapRel

enum zypp::CapDetail::CapRel

Enum values corresponding with libsolv defines.

Note
  MPL check in PoolImpl.cc

Enumerator
REL_NONE | Not an expression.
CAP_AND | `and`
CAP_OR | `or`
CAP_COND | `if`
CAP_UNLESS | `unless`
CAP_ELSE | `else`
CAP_WITH | `with`
CAP_WITHOUT | `without`
CAP_NAMESPACE |
CAP_ARCH | Used internally.

Definition at line 379 of file Capability.h.

## Constructor & Destructor Documentation

## ◆ CapDetail() [1/3]

zypp::CapDetail::CapDetail | ( |  | ) |
| inline

Definition at line 397 of file Capability.h.

## ◆ CapDetail() [2/3]

zypp::CapDetail::CapDetail | ( | const Capability & | cap_r | ) |
| inline explicit

Definition at line 400 of file Capability.h.

## ◆ CapDetail() [3/3]

zypp::CapDetail::CapDetail | ( | sat::detail::IdType | id_r | ) |
| inline explicit

Definition at line 403 of file Capability.h.

## Member Function Documentation

## ◆ kind()

Kind zypp::CapDetail::kind | ( |  | ) | const
| inline

Definition at line 408 of file Capability.h.

## ◆ isNull()

bool zypp::CapDetail::isNull | ( |  | ) | const
| inline

Definition at line 409 of file Capability.h.

## ◆ isNamed()

bool zypp::CapDetail::isNamed | ( |  | ) | const
| inline

Definition at line 410 of file Capability.h.

## ◆ isVersioned()

bool zypp::CapDetail::isVersioned | ( |  | ) | const
| inline

Definition at line 411 of file Capability.h.

## ◆ isSimple()

bool zypp::CapDetail::isSimple | ( |  | ) | const
| inline

Definition at line 412 of file Capability.h.

## ◆ isExpression()

bool zypp::CapDetail::isExpression | ( |  | ) | const
| inline

Definition at line 413 of file Capability.h.

## ◆ hasArch()

bool zypp::CapDetail::hasArch | ( |  | ) | const
| inline

Definition at line 417 of file Capability.h.

## ◆ arch()

IdString zypp::CapDetail::arch | ( |  | ) | const
| inline

Definition at line 418 of file Capability.h.

## ◆ name()

IdString zypp::CapDetail::name | ( |  | ) | const
| inline

Definition at line 419 of file Capability.h.

## ◆ op()

Rel zypp::CapDetail::op | ( |  | ) | const
| inline

Definition at line 420 of file Capability.h.

## ◆ ed()

Edition zypp::CapDetail::ed | ( |  | ) | const
| inline

Definition at line 421 of file Capability.h.

## ◆ lhs()

Capability zypp::CapDetail::lhs | ( |  | ) | const
| inline

Definition at line 426 of file Capability.h.

## ◆ capRel()

CapRel zypp::CapDetail::capRel | ( |  | ) | const
| inline

Definition at line 427 of file Capability.h.

## ◆ rhs()

Capability zypp::CapDetail::rhs | ( |  | ) | const
| inline

Definition at line 428 of file Capability.h.

## ◆ _init()

void zypp::CapDetail::_init | ( |  | ) |
| private

Definition at line 641 of file Capability.cc.

## Member Data Documentation

## ◆ _kind

Kind zypp::CapDetail::_kind
| private

Definition at line 434 of file Capability.h.

## ◆ _lhs

sat::detail::IdType zypp::CapDetail::_lhs
| private

Definition at line 435 of file Capability.h.

## ◆ _rhs

sat::detail::IdType zypp::CapDetail::_rhs
| private

Definition at line 436 of file Capability.h.

## ◆ _flag

unsigned zypp::CapDetail::_flag
| private

Definition at line 437 of file Capability.h.

## ◆ _archIfSimple

sat::detail::IdType zypp::CapDetail::_archIfSimple
| private

Definition at line 438 of file Capability.h.

The documentation for this class was generated from the following files:

- zypp/Capability.h
- zypp/Capability.cc